/****************************************************************************\
                          hwprobe.c  -  description
                             -------------------
    begin                : 2004ǯ  5  4  22:35:53 JST
    copyright            : (C) 2004 by Naoya OYAMA
    email                : naoyan@minaminoshima.org
    Most code ripped from:
                           hwsetup.c
                           fdisk.c
\****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#undef _i_wanna_build_this_crap_
/* #define _i_wanna_build_this_crap_ 1 */ /* Necessary for ISAPNP */
#include <kudzu/kudzu.h>
#if defined(_i_wanna_build_this_crap_)
#include <kudzu/isapnp.h>
#endif

#include "disk.h"
#include <linux/hdreg.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include "get_blocks.h"
#include <linux/major.h>
#include <stdlib.h>
#include <sys/utsname.h>
#include "common.h"
#include "nls.h"
#include "hwprobe.h"

/* function proto type */
void get_kernel_geometry(void);
static void get_sectorsize(void);
void guess_device_type(void);
static void get_partition_table_geometry(void);
int valid_part_table_flag(unsigned char *b);
static void store4_little_endian(unsigned char *cp, unsigned int val);
static unsigned int read4_little_endian(unsigned char *cp);
static void set_start_sect(partition *p, unsigned int start_sect);
unsigned int get_start_sect(partition *p);
static void set_nr_sects(partition *p, unsigned int nr_sects);
unsigned int get_nr_sects(partition *p);
static void seek_sector(unsigned int secno);
static void read_sector(unsigned int secno, unsigned char *buf);
static void read_pte(int pno, unsigned int offset,pte *ptes);
static unsigned int get_partition_start(pte *pe);
partition *get_part_table(int i, pte *ptes);
void set_all_unchanged(pte *ptes);
void set_changed(int i, pte *ptes);
static systypes *get_sys_types(void);
char *partition_type(unsigned char type);
void read_extended(int ext, pte *ptes);
void delete_partition(int i, pte *ptes);
static void clear_partition(partition *p);
int get_boot(harddisk *disk);
void get_geometry(harddisk *disk);
void update_units(void);
static void list_table(harddisk *disk);
int is_cleared_partition(partition *p);
static void long2chs(ulong ls, unsigned int *c, unsigned int *h, unsigned int *s);
static int check_consistency(partition *p, int part);
static int linux_version_code(void);

/* These need to be global, so we can kill them in case of problems */
pid_t wpid=0;
unsigned int  user_cylinders, user_heads, user_sectors;
unsigned int  pt_heads, pt_sectors;
unsigned int  kern_heads, kern_sectors;

unsigned int  heads,
              sectors,
              cylinders,
              sector_size = DEFAULT_SECTOR_SIZE,
              user_set_sector_size = 0,
              sector_offset = 1,
              units_per_sector = 1,
              display_in_cyl_units =1,
              extended_offset = 0;

int  dos_compatible_flag = ~0;

off_t total_number_of_sectors;

unsigned char MBRbuffer[MAX_SECTOR_SIZE];
static int scsi_disk = 0;
static int floppy = 0;

int  ext_index,
     fd,
     partitions = 4;

char *disk_device;

harddisk *probe_disk(int initialize)
{
	int i, j = 0;
	struct device **currentDevs, *d;
	static harddisk disk[DISK_MAX];
	if( initialize )
		memset(disk, 0, sizeof(harddisk)*DISK_MAX);
#if 0
	else 
		for( i=0; i < DISK_MAX ; i++ ) {
			memset(disk[i].ptes, 0, sizeof(pte)*MAXIMUM_PARTS);
			memset(disk[i].part_infos, 0, 
					sizeof(part_info)*MAXIMUM_PARTS);
		}
#endif
	if((currentDevs=probeDevices(CLASS_HD, BUS_SCSI|BUS_IDE, PROBE_ALL))==NULL) return NULL;
	for(i=0;(d=currentDevs[i]);i++)
	{
		if ( j+1 >= DISK_MAX ) break;
		disk[j].device = d->device;
		strncpy(disk[j].file, DEV_DIRECTORY, 127);
		strncat(disk[j].file, d->device, 127-strlen(d->device));
		disk[j].file[127] = 0;
		disk[j].desc = d->desc;
		disk[j].bus  = d->bus==BUS_OTHER?"OTHER":   d->bus==BUS_PCI?"PCI":
                        d->bus==BUS_SBUS?"SBUS":     d->bus==BUS_PSAUX?"PSAUX":
                        d->bus==BUS_SERIAL?"SERIAL": d->bus==BUS_PARALLEL?"PARALLEL":
                        d->bus==BUS_SCSI?"SCSI":     d->bus==BUS_IDE?"IDE":
                        d->bus==BUS_DDC?"DDC":       d->bus==BUS_USB?"USB":
                        d->bus==BUS_KEYBOARD?"KEYBOARD":
                        "UNKNOWN";
		disk_device = disk->file;
		get_boot(&disk[j]);
		list_table(&disk[j]);
		j++;

	}
	srand((unsigned)time(NULL));
	return disk;
}

void get_kernel_geometry(void) {
        struct hd_geometry geometry;

        if(seteuid(0)!=0) exit(-1);

        if (!ioctl(fd, HDIO_GETGEO, &geometry)) {
                kern_heads = geometry.heads;
                kern_sectors = geometry.sectors;
                /* never use geometry.cylinders - it is truncated */
        }
        if(seteuid(getuid())!=0) exit(-1);
}


void fatal(enum failure why) {
        char    error[LINE_LENGTH],
                *message = error;

        switch (why) {
                case usage: message = _(
    "Usage: fdisk [-b SSZ] [-u] DISK     Change partition table\n"
    "       fdisk -l [-b SSZ] [-u] DISK  List partition table(s)\n"
    "       fdisk -s PARTITION           Give partition size(s) in blocks\n"
    "       fdisk -v                     Give fdisk version\n"
    "Here DISK is something like /dev/hdb or /dev/sda\n"
    "and PARTITION is something like /dev/hda7\n"
    "-u: give Start and End in sector (instead of cylinder) units\n"
    "-b 2048: (for certain MO disks) use 2048-byte sectors\n");
                            break;
                    case usage2:
                      /* msg in cases where fdisk used to probe */
                            message = _(
"Usage: fdisk [-l] [-b SSZ] [-u] device\n"
"E.g.: fdisk /dev/hda  (for the first IDE disk)\n"
"  or: fdisk /dev/sdc  (for the third SCSI disk)\n"
"  or: fdisk /dev/eda  (for the first PS/2 ESDI drive)\n"
"  or: fdisk /dev/rd/c0d0  or: fdisk /dev/ida/c0d0  (for RAID devices)\n"
"  ...\n");
                            break;
                    case unable_to_open:
                            snprintf(error, sizeof(error),
                                     _("Unable to open %s\n"), disk_device);
                            break;
                    case unable_to_read:
                            snprintf(error, sizeof(error),
                                     _("Unable to read %s\n"), disk_device);
                           break;
                    case unable_to_seek:
                            snprintf(error, sizeof(error),
                                   _("Unable to seek on %s\n"),disk_device);
                            break;
                    case unable_to_write:
                           snprintf(error, sizeof(error),
                                    _("Unable to write %s\n"), disk_device);
                            break;
                    case ioctl_error:
                        snprintf(error, sizeof(error),
                                 _("BLKGETSIZE ioctl failed on %s\n"),
                                 disk_device);
                        break;
                case out_of_memory:
                       message = _("Unable to allocate any more memory\n");
                        break;
                default:
                        message = _("Fatal error\n");
        }

        fputc('\n', stderr);
        fputs(message, stderr);
        exit(1);
}

static void
get_sectorsize(void) {
#if defined(BLKSSZGET) && defined(__linux__)
        if (!user_set_sector_size &&
            linux_version_code() >= MAKE_VERSION(2,3,3)) {
                int arg;
                if (ioctl(fd, BLKSSZGET, &arg) == 0)
                       sector_size = arg;
                if (sector_size != DEFAULT_SECTOR_SIZE)
                        printf(_("Note: sector size is %d (not %d)\n"),
                               sector_size, DEFAULT_SECTOR_SIZE);
        }
#else
        /* maybe the user specified it; and otherwise we still
           have the DEFAULT_SECTOR_SIZE default */
#endif
}

void guess_device_type(void) {
	struct stat bootstat;

	if (fstat (fd, &bootstat) < 0) {
		scsi_disk = 0;
		floppy = 0;
#ifdef __linux__
	} else if (S_ISBLK(bootstat.st_mode)
	   && (major(bootstat.st_rdev) == IDE0_MAJOR ||
	  major(bootstat.st_rdev) == IDE1_MAJOR)) {
		scsi_disk = 0;
		floppy = 0;
	} else if (S_ISBLK(bootstat.st_mode)
	   && major(bootstat.st_rdev) == FLOPPY_MAJOR) {
		scsi_disk = 0;
		floppy = 1;
#endif
	} else {
		scsi_disk = 1;
		floppy = 0;
	}
}

static void
get_partition_table_geometry(void) {
	unsigned char *bufp = MBRbuffer;
	partition *p;
	int i, h, s, hh, ss;
	int first = 1;
	int bad = 0;

	if (!(valid_part_table_flag(bufp)))
		return;

	hh = ss = 0;
	for (i=0; i<4; i++) {
		p = pt_offset(bufp, i);
		if (p->sys_ind != 0) {
			h = (p->end_head + 1);
			s = (p->end_sector & 077);
			if (first) {
				hh = h;
				ss = s;
				first = 0;
			} else if (hh != h || ss != s)
				bad = 1;
		}
	}

	if (!first && !bad) {
		pt_heads = hh;
		pt_sectors = ss;
	}
}

int
valid_part_table_flag(unsigned char *b) {
        return (b[510] == 0x55 && b[511] == 0xaa);
}


/* start_sect and nr_sects are stored little endian on all machines */
/* moreover, they are not aligned correctly */
static void
store4_little_endian(unsigned char *cp, unsigned int val) {
        cp[0] = (val & 0xff);
        cp[1] = ((val >> 8) & 0xff);
        cp[2] = ((val >> 16) & 0xff);
        cp[3] = ((val >> 24) & 0xff);
}

static unsigned int
read4_little_endian(unsigned char *cp) {
        return (unsigned int)(cp[0]) + ((unsigned int)(cp[1]) << 8)
                + ((unsigned int)(cp[2]) << 16)
                + ((unsigned int)(cp[3]) << 24);
}

static void
set_start_sect(partition *p, unsigned int start_sect) {
        store4_little_endian(p->start4, start_sect);
}

unsigned int
get_start_sect(partition *p) {
        return read4_little_endian(p->start4);
}

static void
set_nr_sects(partition *p, unsigned int nr_sects) {
        store4_little_endian(p->size4, nr_sects);
}

unsigned int
get_nr_sects(partition *p) {
        return read4_little_endian(p->size4);
}

static void
seek_sector(unsigned int secno) {
        off_t offset = (off_t) secno * sector_size;
        if (lseek(fd, offset, SEEK_SET) == (off_t) -1)
                fatal(unable_to_seek);
}

static void
read_sector(unsigned int secno, unsigned char *buf) {
        if ( secno >= total_number_of_sectors)
            memset(buf, 0, sector_size);
        else {
            seek_sector(secno);
            if (read(fd, buf, sector_size) != sector_size)
                    fatal(unable_to_read);
        }
}

/* Allocate a buffer and read a partition table sector */
static void
read_pte(int pno, unsigned int offset,pte *ptes) {
        pte *pe = &ptes[pno];

        pe->offset = offset;
        pe->sectorbuffer = (unsigned char *) malloc(sector_size);
        if (!pe->sectorbuffer)
                fatal(out_of_memory);
        read_sector(offset, pe->sectorbuffer);
        pe->changed = 0;
        pe->part_table = pe->ext_pointer = NULL;
}

static unsigned int
get_partition_start(pte *pe) {
        return pe->offset + get_start_sect(pe->part_table);
}

partition *
get_part_table(int i, pte *ptes) {
        return ptes[i].part_table;
}

void
set_all_unchanged(pte *ptes) {
        int i;

        for (i = 0; i < MAXIMUM_PARTS; i++)
                ptes[i].changed = 0;
}

void
set_changed(int i, pte *ptes) {
        ptes[i].changed = 1;
}

static systypes *
get_sys_types(void) {
        return (
#if 0
                sun_label ? sun_sys_types :
                sgi_label ? sgi_sys_types :
#endif
                i386_sys_types);
}

char *partition_type(unsigned char type)
{
        int i;
        systypes *types = get_sys_types();

        for (i=0; types[i].name; i++)
                if (types[i].type == type)
                        return _(types[i].name);

        return NULL;
}

void read_extended(int ext, pte *ptes) {
        int i;
        pte *pex;
        partition *p, *q;

        ext_index = ext;
        pex = &ptes[ext];
        pex->ext_pointer = pex->part_table;

        p = pex->part_table;
        if (!get_start_sect(p)) {
                fprintf(stderr,
                        _("Bad offset in primary extended partition\n"));
                return;
        }

        while (IS_EXTENDED (p->sys_ind)) {
                pte *pe = &ptes[partitions];

                if (partitions >= MAXIMUM_PARTS) {
                        /* This is not a Linux restriction, but
                           this program uses arrays of size MAXIMUM_PARTS.
                           Do not try to `improve' this test. */
                        pte *pre = &ptes[partitions-1];

                        fprintf(stderr,
                               _("Warning: deleting partitions after %d\n"),
                                partitions);
                        clear_partition(pre->ext_pointer);
                        pre->changed = 1;
                        return;
                }

                read_pte(partitions, extended_offset + get_start_sect(p), ptes);

                if (!extended_offset)
                        extended_offset = get_start_sect(p);

                q = p = pt_offset(pe->sectorbuffer, 0);
                for (i = 0; i < 4; i++, p++) if (get_nr_sects(p)) {
                        if (IS_EXTENDED (p->sys_ind)) {
                                if (pe->ext_pointer)
                                        fprintf(stderr,
                                                _("Warning: extra link "
                                                  "pointer in partition table"
                                                    " %d\n"), partitions + 1);
                                else
                                        pe->ext_pointer = p;
                        } else if (p->sys_ind) {
                                if (pe->part_table)
                                        fprintf(stderr,
                                                _("Warning: ignoring extra "
                                                  "data in partition table"
                                                    " %d\n"), partitions + 1);
                                else
                                        pe->part_table = p;
                        }
                }

                /* very strange code here... */
                if (!pe->part_table) {
                        if (q != pe->ext_pointer)
                                pe->part_table = q;
                        else
                                pe->part_table = q + 1;
                }
                if (!pe->ext_pointer) {
                        if (q != pe->part_table)
                                pe->ext_pointer = q;
                        else
                                pe->ext_pointer = q + 1;
                }

                p = pe->ext_pointer;
                partitions++;
        }

        /* remove empty links */
 remove:
        for (i = 4; i < partitions; i++) {
                pte *pe = &ptes[i];

                if (!get_nr_sects(pe->part_table) &&
                    (partitions > 5 || ptes[4].part_table->sys_ind)) {
                        printf("omitting empty partition (%d)\n", i+1);
                        delete_partition(i, pe);
                        goto remove;    /* numbering changed */
                }
        }
}

void delete_partition(int i, pte *ptes) {
        pte *pe = &ptes[i];
        partition *p = pe->part_table;
        partition *q = pe->ext_pointer;

	/* Note that for the fifth partition (i == 4) we don't actually
	 *  * decrement partitions.
	 *   */

#if 0
        if (warn_geometry())
                return;         /* C/H/S not set */
#endif
        pe->changed = 1;

#if 0
        if (sun_label) {
                sun_delete_partition(i);
                return;
        }

        if (sgi_label) {
                sgi_delete_partition(i);
                return;
        }
#endif
        if (i < 4) {
                if (IS_EXTENDED (p->sys_ind) && i == ext_index) {
                        partitions = 4;
                        ptes[ext_index].ext_pointer = NULL;
                        extended_offset = 0;
                }
                clear_partition(p);
                return;
        }

        if (!q->sys_ind && i > 4) {
                /* the last one in the chain - just delete */
                --partitions;
                --i;
                clear_partition(ptes[i].ext_pointer);
                ptes[i].changed = 1;
        } else {
                /* not the last one - further ones will be moved down */
                if (i > 4) {
                        /* delete this link in the chain */
                        p = ptes[i-1].ext_pointer;
                        *p = *q;
                        set_start_sect(p, get_start_sect(q));
                        set_nr_sects(p, get_nr_sects(q));
                        ptes[i-1].changed = 1;
                } else if (partitions > 5) {    /* 5 will be moved to 4 */
                        /* the first logical in a longer chain */
                        pe = &ptes[5];

                        if (pe->part_table) /* prevent SEGFAULT */
                                set_start_sect(pe->part_table,
                                               get_partition_start(pe) -
                                                      extended_offset);
                        pe->offset = extended_offset;
                        pe->changed = 1;
                }

                if (partitions > 5) {
                        partitions--;
                        while (i < partitions) {
                                ptes[i] = ptes[i+1];
                                i++;
                        }
                } else
                        /* the only logical: clear only */
                        clear_partition(ptes[i].part_table);
        }
}

static void
clear_partition(partition *p) {
        if (!p)
                return;
        p->boot_ind = 0;
        p->head = 0;
        p->sector = 0;
        p->cyl = 0;
        p->sys_ind = 0;
        p->end_head = 0;
        p->end_sector = 0;
        p->end_cyl = 0;
        set_start_sect(p,0);
        set_nr_sects(p,0);
}

int get_boot(harddisk *disk) {
        int i;

        partitions = 4;

        for (i = 0; i < 4; i++) {
                pte *pe = &disk->ptes[i];

                pe->part_table = pt_offset(MBRbuffer, i);
                pe->ext_pointer = NULL;
                pe->offset = 0;
                pe->sectorbuffer = MBRbuffer;
                pe->changed = 0;
        }

        memset(MBRbuffer, 0, 512);

        if(seteuid(0)!=0) exit(-1);
        if ((fd = open(disk->file, O_RDONLY)) < 0)
            fatal(unable_to_open);

        if (512 != read(fd, MBRbuffer, 512)) {
		if(0)
                fatal(out_of_memory);
        }

        get_geometry(disk);

        update_units();

#if 0
        warn_cylinders();
        warn_geometry();
#endif

        for (i = 0; i < 4; i++) {
                pte *pe = &disk->ptes[i];

                if (IS_EXTENDED (pe->part_table->sys_ind)) {
                        if (partitions != 4)
                                fprintf(stderr, _("Ignoring extra extended "
                                        "partition %d\n"), i + 1);
                        else
                                read_extended(i, disk->ptes);
                }
        }

        if(seteuid(getuid())!=0) exit(-1);
        close(fd);
        disk->partitions = partitions;

        return 0;
}

void
get_geometry(harddisk *disk) {
        int sec_fac;
        unsigned long long bytes;       /* really u64 */

        get_sectorsize();
        sec_fac = sector_size / 512;
        guess_device_type();
        heads = cylinders = sectors = 0;
        kern_heads = kern_sectors = 0;
        pt_heads = pt_sectors = 0;

        get_kernel_geometry();
        get_partition_table_geometry();

        heads = user_heads ? user_heads :
                pt_heads ? pt_heads :
                kern_heads ? kern_heads : 255;
        sectors = user_sectors ? user_sectors :
                pt_sectors ? pt_sectors :
                kern_sectors ? kern_sectors : 63;

        total_number_of_sectors = get_blocks(fd);
               bytes = ((unsigned long long) total_number_of_sectors) << 9;

               sector_offset = 1;
               if (dos_compatible_flag)
                       sector_offset = sectors;

               cylinders = total_number_of_sectors / (heads * sectors * sec_fac);
               if (!cylinders)
                       cylinders = user_cylinders;

        disk->geometry.cylinders = cylinders;
        disk->geometry.heads     = heads;
        disk->geometry.sectors   = sectors;
        disk->cylinder_size = heads * sectors * sector_size;
        disk->sector_size = sector_size;
        disk->total_number_of_sectors = total_number_of_sectors;
}

void update_units(void)
{
        int cyl_units = heads * sectors;

        if (display_in_cyl_units && cyl_units)
                units_per_sector = cyl_units;
        else
                units_per_sector = 1;   /* in sectors */
}

static void
list_table(harddisk *disk) {
        partition *p;
        char *type;
        int i, w;

        /* Heuristic: we list partition 3 of /dev/foo as /dev/foo3,
	 * but if the device name ends in a digit, say /dev/foo1,
	 * then the partition is called /dev/foo1p3. */
        w = strlen(disk->file);
        if (w && isdigit(disk->file[w-1]))
                w++;
        if (w < 5)
                w = 5;

        for (i = 0; i < partitions; i++) {
                pte *pe = &disk->ptes[i];
                part_info *pi = &disk->part_infos[i];
                char *ptr;

                p = pe->part_table;
                if (p && !is_cleared_partition(p)) {
                        unsigned int psects = get_nr_sects(p);
                        unsigned int pblocks = psects;
                        unsigned int podd = 0;

                        if (sector_size < 1024) {
                                pblocks /= (1024 / sector_size);
                                podd = psects % (1024 / sector_size);
                        }
                        if (sector_size > 1024)
                                pblocks *= (sector_size / 1024);
                        ptr = partname(disk->file, i+1, w+2);
                        strncpy(pi->file, ptr, 127);
                        ptr = strchr(pi->file, ' ');
                        if ( ptr != NULL)
                          *ptr = 0;
                        pi->file[127] = 0;
                        pi->capa = pblocks >> 10;
                        pi->end_cyl = cround(get_partition_start(pe) + psects
                                        - (psects ? 1 : 0 ));
                        pi->start_cyl = cround(get_partition_start(pe));
                        ptr = (type =partition_type(p->sys_ind)) ?
                              type : _("Unknown");
                        strncpy(pi->system, ptr, 127);
                        pi->system[127] = 0;
                        pi->is_extended = IS_EXTENDED(p->sys_ind);
                        if ( pi->is_extended )
                          ptr = _("Extended");
                        else
                          ptr = (type = guess_fstype_from_superblock(pi->file)) ?
                                type : _("Unknown");
                        strncpy(pi->fs, ptr, sizeof(pi->fs)-1);
                        pi->fs[sizeof(pi->fs)-1] = 0;
                           
			pi->partition_status = check_consistency(p, i);
			pi->is_mounted = _is_mounted(pi->file);
                }
        }

        /* Is partition table in disk order? It need not be, but... */
        /* partition table entries are not checked for correct order if this
	 * is a sgi, sun or aix labeled disk... */
}

int is_cleared_partition(partition *p) {
        return !(!p || p->boot_ind || p->head || p->sector || p->cyl ||
                 p->sys_ind || p->end_head || p->end_sector || p->end_cyl ||
                 get_start_sect(p) || get_nr_sects(p));
}

/* check_consistency() and long2chs() added Sat Mar 6 12:28:16 1993,
 * faith@cs.unc.edu, based on code fragments from pfdisk by Gordon W. Ross,
 * Jan.  1990 (version 1.2.1 by Gordon W. Ross Aug. 1990; Modified by S.
 * Lubkin Oct.  1991). */

static void
long2chs(ulong ls, unsigned int *c, unsigned int *h, unsigned int *s) {
        int spc = heads * sectors;

        *c = ls / spc;
        ls = ls % spc;
        *h = ls / sectors;
        *s = ls % sectors + 1;  /* sectors count from 1 */
}

static int check_consistency(partition *p, int part) {
        unsigned int pbc, pbh, pbs;     /* physical beginning c, h, s */
        unsigned int pec, peh, pes;     /* physical ending c, h, s */
        unsigned int lbc, lbh, lbs;     /* logical beginning c, h, s */
        unsigned int lec, leh, les;     /* logical ending c, h, s */
	int ret = 0;


        if (!heads || !sectors || (part >= 4))
                return(ret);         /* do not check extended partitions */

	/* physical beginning c, h, s */
        pbc = (p->cyl & 0xff) | ((p->sector << 2) & 0x300);
        pbh = p->head;
        pbs = p->sector & 0x3f;

	/* physical ending c, h, s */
        pec = (p->end_cyl & 0xff) | ((p->end_sector << 2) & 0x300);
        peh = p->end_head;
        pes = p->end_sector & 0x3f;

/* compute logical beginning (c, h, s) */
        long2chs(get_start_sect(p), &lbc, &lbh, &lbs);

/* compute logical ending (c, h, s) */
        long2chs(get_start_sect(p) + get_nr_sects(p) - 1, &lec, &leh, &les);

/* Same physical / logical beginning? */

/* Same physical / logical beginning? */
        if (cylinders <= 1024 && (pbc != lbc || pbh != lbh || pbs != lbs)) {
#if 0
                printf(_("Partition %d has different physical/logical "
                        "beginnings (non-Linux?):\n"), part + 1);
                printf(_("     phys=(%d, %d, %d) "), pbc, pbh, pbs);
                printf(_("logical=(%d, %d, %d)\n"),lbc, lbh, lbs);
#endif
		ret |= different_physical_logical_begining;
        }

/* Same physical / logical ending? */
        if (cylinders <= 1024 && (pec != lec || peh != leh || pes != les)) {
#if 0
                printf(_("Partition %d has different physical/logical "
                        "endings:\n"), part + 1);
                printf(_("     phys=(%d, %d, %d) "), pec, peh, pes);
                printf(_("logical=(%d, %d, %d)\n"),lec, leh, les);
#endif
		ret |= different_physical_logical_ending;
        }


       /* Ending on cylinder boundary? */
               if (peh != (heads - 1) || pes != sectors) {
#if 0
                       printf(_("Partition %i does not end on cylinder boundary.\n"),
                               partition + 1);
                       printf(_("     phys=(%d, %d, %d) "), pec, peh, pes);
                       printf(_("should be (%d, %d, %d)\n"),
                       pec, heads - 1, sectors);
#endif
			ret |= does_not_end_cylinder_boundary;
               }
	       return(ret);
}

static int
linux_version_code(void) {
        static int kernel_version = 0;
        struct utsname my_utsname;
        int p, q, r;

        if (!kernel_version && uname(&my_utsname) == 0) {
                p = atoi(strtok(my_utsname.release, "."));
                q = atoi(strtok(NULL, "."));
                r = atoi(strtok(NULL, "."));
                kernel_version = MAKE_VERSION(p,q,r);
        }
        return kernel_version;
}

